﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace pliki_a_tablice_konsola_cz1
{
    internal class Program
    {
        static int[] tab1, tab2;
        static int[,] tab2D;
        static Random los = new Random();

        static int[] BudujTablice(int w, int zakresLosowan)
        {
            int[] t = new int[w];
            for (int i = 0; i < t.GetLength(0); i++) t[i] = los.Next(zakresLosowan) + 1;
            return t;
        }
        //przeciążenie powyższej funkcji
        static int[,] BudujTablice(int w, int k, int zakresLosowan)
        {
            int[,] t = new int[w, k];
            for (int i = 0; i < t.GetLength(0); i++)
                for (int j = 0; j < t.GetLength(1); j++)
                    t[i, j] = los.Next(zakresLosowan) + 1;
            return t;
        }

        static void PokazTablice(int[] t, string naglowek)
        {
            Console.WriteLine(naglowek);
            String s = "";
            for (int i = 0; i < t.GetLength(0); i++)
                s += String.Format("{0} ", t[i]);
            Console.WriteLine(s);
        }
        //przeciążenie powyższej funkcji
        static void PokazTablice(int[,] t, string naglowek)
        {
            Console.WriteLine(naglowek);
            for (int i = 0; i < t.GetLength(0); i++)
            {
                String s = "";
                for (int j = 0; j < t.GetLength(1); j++)
                    s += String.Format("{0} ", t[i, j]);
                Console.WriteLine(s);
            }
        }
        static void ZapiszTabliceDoPliku(StreamWriter p, int[] t)
        {
            int i = 0;
            //zmienna p to strumień klasy plik
            do
            {
                p.Write(String.Format("{0} ", t[i]));
                i++;
            } while (i < t.GetLength(0));
        }
        //przeciążenie powyższej funkcji
        static void ZapiszTabliceDoPliku(StreamWriter p, int[,] t)
        {
            int i = 0;
            //zmienna p to strumień klasy plik
            do
            {
                //zapamietaj jeden wiersz tablicy dwuwymiarowej
                string s = "";
                for (int j = 0; j < t.GetLength(1); j++)
                    s += String.Format("{0} ", t[i, j]);
                //zapisz i przejdź do nowego wiersza
                p.WriteLine(s);
                i++;
            } while (i < t.GetLength(0));
        }
        static int[] BudujTabliceZLinii(string linia)
        {
            string[] s = linia.Split(' ');
            //odejmij 1 bo ostatni znak to spacja
            int[] t = new int[s.Length - 1];
            for (int j = 0; j < t.GetLength(0); j++)
                t[j] = Convert.ToInt32(s[j]);
            return t;
        }
        //przeciążenie powyższej funkcji
        static int[,] BudujTabliceZLinii(string linia1, string linia2)
        {
            string[] kolumna1 = linia1.Split(' ');
            string[] kolumna2 = linia2.Split(' ');
            //odejmij 1 bo ostatni znak to spacja
            int[,] t = new int[kolumna1.Length - 1, 2];
            for (int j = 0; j < t.GetLength(0); j++)
            {
                t[j, 0] = Convert.ToInt32(kolumna1[j]);
                t[j, 1] = Convert.ToInt32(kolumna2[j]);
            }
            return t;
        }
        static void Main(string[] args)
        {
            Console.WriteLine("Witaj w CzD!");
            Console.WriteLine("Podaj ilość wierszy dla tablicy jednowymiarowej: ");
            int n= Convert.ToInt32(Console.ReadLine());
            tab1 = BudujTablice(n, 20);
            tab2 = BudujTablice(n, 50);
            PokazTablice(tab1,"tablica tab1:");
            PokazTablice(tab2,"tablica tab2:");
            Console.WriteLine("Podaj ilość wierszy dla tablicy dwuwymiarowej: ");
            n = Convert.ToInt32(Console.ReadLine());
            tab2D = BudujTablice(n, 2, 50);
            PokazTablice(tab2D,"tablica dwuwymiarowa tab2D:");
            Console.WriteLine("*****ZAPIS DO PLIKU dane.txt*****");
            //false- nadpisze plik jak istnieje
            //true- dopisze do pliku jak istnieje
            StreamWriter plik = new StreamWriter("dane.txt", false);
            ZapiszTabliceDoPliku(plik, tab1);
            plik.Write(Environment.NewLine);
            ZapiszTabliceDoPliku(plik, tab2);
            plik.Write(Environment.NewLine);
            ZapiszTabliceDoPliku(plik, tab2D);
            plik.Close();
            Console.WriteLine("*****ODCZYT PLIKU dane.txt DO EKRANU KONSOLI*****");
            StreamReader plikDoKonsoli = new StreamReader("dane.txt");
            //wczytaj plik do ekranu konsoli
            Console.Write(plikDoKonsoli.ReadToEnd());
            plikDoKonsoli.Close();
            Console.WriteLine("*****ODCZYT PLIKU dane.txt DO TABLIC*****");
            StreamReader plikDoTablic = new StreamReader("dane.txt");
            string linia = "", s1 = "", s2 = "";
            int i = 0;
            while ((linia = plikDoTablic.ReadLine()) != null)
            {
                if (i == 0)
                {
                    tab1 = BudujTabliceZLinii(linia);
                    PokazTablice(tab1, "tablica tab1 odczytana z pliku:");
                }
                if (i == 1)
                {
                    tab2 = BudujTabliceZLinii(linia);
                    PokazTablice(tab2, "tablica tab2 odczytana z pliku:");
                }
                //tablicę dwuwymiarową zapisaną w kolejnych wierszach bez podania
                //poczatkowego rozmiaru zbudujemy posrednio z łancuchów znaków czytanych
                //linia po linii
                if (i > 1)
                {
                    string[] s = linia.Split(' ');
                    s1 += s[0] + " ";
                    s2 += s[1] + " ";
                }
                i++;
            }
            plikDoTablic.Close();
            //odczytałeś wszystkie linie to zbuduj tablicę dwuwymiarową
            tab2D = BudujTabliceZLinii(s1, s2);
            PokazTablice(tab2D,"tablica dwuwymiarowa tab2D odczytana z pliku:");
            Console.ReadKey();
        }
    }
}
